

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.WindRose &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.Template" href="pywws.Template.html" />
    <link rel="prev" title="pywws.Plot" href="pywws.Plot.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.Template.html" title="pywws.Template"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.Plot.html" title="pywws.Plot"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="pywws-windrose">
<h1>pywws.WindRose<a class="headerlink" href="#pywws-windrose" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This routine plots one or more &#8220;wind roses&#8221; (see <a class="reference external" href="http://en.wikipedia.org/wiki/Wind_rose">Wikipedia</a> for a description). Like Plot.py almost everything is controlled by an XML &#8220;recipe&#8221; / template file.</p>
<p>Before writing your own template files, it might be useful to look at some of the examples in the example_graph_templates directory. If (like I was) you are unfamiliar with XML, I suggest reading the <a class="reference external" href="http://www.w3schools.com/xml/">W3 Schools XML tutorial</a>.</p>
</div>
<div class="section" id="xml-graph-file-syntax">
<h2>XML graph file syntax<a class="headerlink" href="#xml-graph-file-syntax" title="Permalink to this headline">¶</a></h2>
<p>Here is the simplest useful wind rose template. It plots wind over the last 24 hours.</p>
<div class="highlight-python"><pre>&lt;?xml version="1.0" encoding="ISO-8859-1"?&gt;
&lt;graph&gt;
  &lt;windrose&gt;
    &lt;ycalc&gt;data['wind_ave']&lt;/ycalc&gt;
  &lt;/windrose&gt;
&lt;/graph&gt;</pre>
</div>
<p>In this example, the root element graph has one windrose element which contains nothing more than a ycalc element.</p>
<p>The complete element hierarchy is shown below.</p>
<div class="highlight-python"><pre>graph
    windrose
        xcalc
        ycalc
        threshold
        colour
        yrange
        points
        source
        title
    start
    stop
    duration
    layout
    size
    fileformat
    lmargin, rmargin, tmargin, bmargin
    title</pre>
</div>
<div class="section" id="graph">
<h3>graph<a class="headerlink" href="#graph" title="Permalink to this headline">¶</a></h3>
<p>This is the root element of the graph XML file. It does not have to be called &#8220;graph&#8221;, but there must be exactly one root element.</p>
</div>
<div class="section" id="windrose">
<h3>windrose<a class="headerlink" href="#windrose" title="Permalink to this headline">¶</a></h3>
<p>A separate plot is drawn for each windrose element, but all share the same time period.</p>
</div>
<div class="section" id="start">
<h3>start<a class="headerlink" href="#start" title="Permalink to this headline">¶</a></h3>
<p>This element sets the date &amp; time of the wind roses. It is used in the constructor of a Python datetime object. For example, to start at noon (local time) on Christmas day 2008: <tt class="docutils literal"><span class="pre">&lt;start&gt;year=2008,</span> <span class="pre">month=12,</span> <span class="pre">day=25,</span> <span class="pre">hour=12&lt;/start&gt;</span></tt>. The default value is (stop - duration).</p>
</div>
<div class="section" id="stop">
<h3>stop<a class="headerlink" href="#stop" title="Permalink to this headline">¶</a></h3>
<p>This element sets the date &amp; time of the end of the wind roses. It is used in the constructor of a Python datetime object. For example, to end at 10 am (local time) on new year&#8217;s day 2009: <tt class="docutils literal"><span class="pre">&lt;stop&gt;year=2009,</span> <span class="pre">month=1,</span> <span class="pre">day=1,</span> <span class="pre">hour=10&lt;/stop&gt;</span></tt>. The default value is (start + duration), unless start is not defined in which case the timestamp of the latest weather station hourly reading is used.</p>
</div>
<div class="section" id="duration">
<h3>duration<a class="headerlink" href="#duration" title="Permalink to this headline">¶</a></h3>
<p>This element sets the duration of wind roses, unless both start and stop are defined. It is used in the constructor of a Python timedelta object. For example, to plot one week: <tt class="docutils literal"><span class="pre">&lt;duration&gt;weeks=1&lt;/duration&gt;</span></tt>. The default value is hours=24.</p>
</div>
<div class="section" id="layout">
<h3>layout<a class="headerlink" href="#layout" title="Permalink to this headline">¶</a></h3>
<p>Controls the layout of the plots. Default is a grid that is wider than it is tall. The layout element specifies rows and columns. For example: <tt class="docutils literal"><span class="pre">&lt;layout&gt;4,</span> <span class="pre">2&lt;/layout&gt;</span></tt> will use a grid of 4 rows and 2 columns.</p>
</div>
<div class="section" id="size">
<h3>size<a class="headerlink" href="#size" title="Permalink to this headline">¶</a></h3>
<p>Sets the overall dimensions of the image file containing the graph. Default is a height of 600 pixels and a width that depends on the layout. Any size element must include both width and height. For example: <tt class="docutils literal"><span class="pre">&lt;size&gt;800,</span> <span class="pre">600&lt;/size&gt;</span></tt> will produce an image 800 pixels wide and 600 pixels high.</p>
</div>
<div class="section" id="fileformat">
<h3>fileformat<a class="headerlink" href="#fileformat" title="Permalink to this headline">¶</a></h3>
<p>Sets the image format of the file containing the plots. Default is png. Any string recognised by your installation of gnuplot should do. For example: <tt class="docutils literal"><span class="pre">&lt;fileformat&gt;gif&lt;/fileformat&gt;</span></tt> will produce a GIF image.</p>
</div>
<div class="section" id="lmargin-rmargin-tmargin-bmargin">
<h3>lmargin, rmargin, tmargin, bmargin<a class="headerlink" href="#lmargin-rmargin-tmargin-bmargin" title="Permalink to this headline">¶</a></h3>
<p>Over-rides the automatically computed left, right, top or bottom margin. Supply any positive real number, for example <tt class="docutils literal"><span class="pre">&lt;lmargin&gt;1.3&lt;/lmargin&gt;</span></tt>. Some experimentation may be necessary to find the best values.</p>
</div>
<div class="section" id="title">
<h3>title<a class="headerlink" href="#title" title="Permalink to this headline">¶</a></h3>
<p>Sets the overall title of the plots. A single line of text, for example: <tt class="docutils literal"><span class="pre">&lt;title&gt;Today's</span> <span class="pre">weather&lt;/title&gt;</span></tt>. This title appears at the very top, outside any plot area.</p>
</div>
<div class="section" id="xcalc">
<h3>xcalc<a class="headerlink" href="#xcalc" title="Permalink to this headline">¶</a></h3>
<p>Selects if data is included in the wind rose. The value should be a valid Python logical expression. For example, to plot a rose for afternoon winds only: <tt class="docutils literal"><span class="pre">&lt;xcalc&gt;data['idx'].hour</span> <span class="pre">&amp;gt;=</span> <span class="pre">12&lt;/xcalc&gt;</span></tt>. This allows aggregation of afternoon wind data over several days. Remember that data is indexed in UTC, so you need to use an expression that takes account of your time zone. The default value is &#8216;True&#8217;.</p>
</div>
<div class="section" id="ycalc">
<h3>ycalc<a class="headerlink" href="#ycalc" title="Permalink to this headline">¶</a></h3>
<p>Selects the data to be plotted. Any one line Python expression that returns a single float value can be used. At its simplest this just selects one value from the &#8220;data&#8221; dictionary, for example: <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;data['wind_ave']&lt;/ycalc&gt;</span></tt>. To convert to mph use: <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;data['wind_ave']</span> <span class="pre">*</span> <span class="pre">3.6</span> <span class="pre">/</span> <span class="pre">1.609344&lt;/ycalc&gt;</span></tt>. You are unlikely to want to use anything other than &#8216;wind_ave&#8217; here.</p>
</div>
<div class="section" id="threshold">
<h3>threshold<a class="headerlink" href="#threshold" title="Permalink to this headline">¶</a></h3>
<p>Sets the thresholds for each colour on the rose petals. Defaults are based on the Wikipedia example. The values should be a correctly ordered list of real numbers, for example: <tt class="docutils literal"><span class="pre">&lt;threshold&gt;0.5,</span> <span class="pre">3.5,</span> <span class="pre">7.5,</span> <span class="pre">12.5,</span> <span class="pre">18.5,</span> <span class="pre">24.5,</span> <span class="pre">31.5&lt;/threshold&gt;</span></tt> approximates to the Beaufort scale, if ycalc has been set to convert windspeeds to mph.</p>
</div>
<div class="section" id="colour">
<h3>colour<a class="headerlink" href="#colour" title="Permalink to this headline">¶</a></h3>
<p>Sets the colours of the threshold petal segments. Any sequence of integer values is accepted. The mapping of colours to numbers is set by gnuplot. Default value is 0, 1, 2, 3, etc.</p>
</div>
<div class="section" id="yrange">
<h3>yrange<a class="headerlink" href="#yrange" title="Permalink to this headline">¶</a></h3>
<p>Sets the upper limits of the axes. The rose shows what percentage of the time the wind came from a particular direction. For example, if you live somewhere with a very steady wind you might want to allow higher percentages than normal: <tt class="docutils literal"><span class="pre">&lt;yrange&gt;91&lt;/yrange&gt;</span></tt>. Auto-scaling is also possible, using an asterisk: <tt class="docutils literal"><span class="pre">&lt;yrange&gt;*&lt;/yrange&gt;</span></tt></p>
</div>
<div class="section" id="points">
<h3>points<a class="headerlink" href="#points" title="Permalink to this headline">¶</a></h3>
<p>Sets the text of the compass points. The defaults are &#8216;N&#8217;, &#8216;S&#8217;, &#8216;E&#8217; &amp; &#8216;W&#8217;. For graphs in another language you can over-ride this, for example: <tt class="docutils literal"><span class="pre">&lt;points&gt;'No',</span> <span class="pre">'Zu',</span> <span class="pre">'Oo',</span> <span class="pre">'We'&lt;/points&gt;</span></tt>. (The preferred way to do this is to create a language file, see Localisation.py.)</p>
</div>
<div class="section" id="source">
<h3>source<a class="headerlink" href="#source" title="Permalink to this headline">¶</a></h3>
<p>Select the weather data to be plotted. Permitted values are <tt class="docutils literal"><span class="pre">&lt;source&gt;raw&lt;/source&gt;</span></tt>, <tt class="docutils literal"><span class="pre">&lt;source&gt;hourly&lt;/source&gt;</span></tt>, <tt class="docutils literal"><span class="pre">&lt;source&gt;daily&lt;/source&gt;</span></tt> and <tt class="docutils literal"><span class="pre">&lt;source&gt;monthly&lt;/source&gt;</span></tt>. Default is raw. Note that the different sources have different data dictionaries, so this choice affects ycalc.</p>
</div>
<div class="section" id="id1">
<h3>title<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
<p>Sets the title of the plot. A single line of text, for example: <tt class="docutils literal"><span class="pre">&lt;title&gt;Morning</span> <span class="pre">winds&lt;/title&gt;</span></tt>. This title appears within the plot area, above the threshold colour key.</p>
</div>
</div>
<div class="section" id="module-pywws.WindRose">
<span id="detailed-api"></span><h2>Detailed API<a class="headerlink" href="#module-pywws.WindRose" title="Permalink to this headline">¶</a></h2>
<p>Plot a &#8220;wind rose&#8221;.</p>
<p>usage: python WindRose.py [options] data_dir temp_dir xml_file output_file
options are:</p>
<blockquote>
-h or &#8211;help            display this help</blockquote>
<p>data_dir is the root directory of the weather data
temp_dir is a workspace for temporary files e.g. /tmp
xml_file is the name of the source file that describes the plot
output_file is the name of the image file to be created e.g. 24hrs.png</p>
<p class="rubric">Functions</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.WindRose.main" title="pywws.WindRose.main"><tt class="xref py py-obj docutils literal"><span class="pre">main</span></tt></a>([argv])</td>
<td></td>
</tr>
</tbody>
</table>
<p class="rubric">Classes</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.WindRose.RosePlotter" title="pywws.WindRose.RosePlotter"><tt class="xref py py-obj docutils literal"><span class="pre">RosePlotter</span></tt></a>(params,&nbsp;raw_data,&nbsp;hourly_data,&nbsp;...)</td>
<td></td>
</tr>
</tbody>
</table>
<dl class="class">
<dt id="pywws.WindRose.RosePlotter">
<em class="property">class </em><tt class="descclassname">pywws.WindRose.</tt><tt class="descname">RosePlotter</tt><big>(</big><em>params</em>, <em>raw_data</em>, <em>hourly_data</em>, <em>daily_data</em>, <em>monthly_data</em>, <em>work_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pywws.WindRose.RosePlotter.GetPlotList">
<tt class="descname">GetPlotList</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter.GetPlotList"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter.GetPlotList" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.WindRose.RosePlotter.GetDefaultRows">
<tt class="descname">GetDefaultRows</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter.GetDefaultRows"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter.GetDefaultRows" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.WindRose.RosePlotter.GetDefaultPlotSize">
<tt class="descname">GetDefaultPlotSize</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter.GetDefaultPlotSize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter.GetDefaultPlotSize" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.WindRose.RosePlotter.GetPreamble">
<tt class="descname">GetPreamble</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter.GetPreamble"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter.GetPreamble" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.WindRose.RosePlotter.PlotData">
<tt class="descname">PlotData</tt><big>(</big><em>plot_no</em>, <em>plot</em>, <em>source</em><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#RosePlotter.PlotData"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.RosePlotter.PlotData" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="function">
<dt id="pywws.WindRose.main">
<tt class="descclassname">pywws.WindRose.</tt><tt class="descname">main</tt><big>(</big><em>argv=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/WindRose.html#main"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.WindRose.main" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.WindRose</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#xml-graph-file-syntax">XML graph file syntax</a><ul>
<li><a class="reference internal" href="#graph">graph</a></li>
<li><a class="reference internal" href="#windrose">windrose</a></li>
<li><a class="reference internal" href="#start">start</a></li>
<li><a class="reference internal" href="#stop">stop</a></li>
<li><a class="reference internal" href="#duration">duration</a></li>
<li><a class="reference internal" href="#layout">layout</a></li>
<li><a class="reference internal" href="#size">size</a></li>
<li><a class="reference internal" href="#fileformat">fileformat</a></li>
<li><a class="reference internal" href="#lmargin-rmargin-tmargin-bmargin">lmargin, rmargin, tmargin, bmargin</a></li>
<li><a class="reference internal" href="#title">title</a></li>
<li><a class="reference internal" href="#xcalc">xcalc</a></li>
<li><a class="reference internal" href="#ycalc">ycalc</a></li>
<li><a class="reference internal" href="#threshold">threshold</a></li>
<li><a class="reference internal" href="#colour">colour</a></li>
<li><a class="reference internal" href="#yrange">yrange</a></li>
<li><a class="reference internal" href="#points">points</a></li>
<li><a class="reference internal" href="#source">source</a></li>
<li><a class="reference internal" href="#id1">title</a></li>
</ul>
</li>
<li><a class="reference internal" href="#module-pywws.WindRose">Detailed API</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.Plot.html"
                        title="previous chapter">pywws.Plot</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.Template.html"
                        title="next chapter">pywws.Template</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.Template.html" title="pywws.Template"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.Plot.html" title="pywws.Plot"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>